#!/usr/bin/perl

# Globals

    push(@INC, "/usr/local/www/cgi-bin");
    require 'qos-lib.pl';
    require 'ctime.pl';

    &ReadInput(*INPUT);
    &ParseData(*GLOBAL, $INPUT);
    &set_var;

    if ($flow_edit ne "") {
	if ($flow_edit eq "Move") {
	    &move_rule;
	}
	elsif ($flow_edit eq "Edit" || $flow_edit eq "ReEdit" || 
	    $flow_edit eq "Copy" || $flow_edit eq "Create") {
	    	&default_edit_params;
	}
    }

#print "End: ", &ctime(time), "<br>\n";
    &PrintHeadToe("TRAILER", 
	"", 
	"/conf/conf_view_qos3.html", 
	"/cgi-bin/qos.pl",
	"/cgi-bin/change_rule.pl?IHelp=$nhelp",
	"/cgi-bin/html_page?TEMPLATE=main");


#############################################

sub move_rule {
    if ($ihelp eq "on") {
	print "<img src=\"/images/config/helpbar.gif\"><br>\n";
	print "<font -= 2>\n";
	print "Policy rule matching are processed in strict Top-to-bottom fashion.  Therefore, it is very important to make sure the rules are configured in the order desired.  In general, more specific rules should be configured before less specific rules.<br>\n<br>\n";
	print "To re-order the rules, select the rule that you wish to move from the \"Move rule\" list, then select a rule from the \"Before rule\" list, and then press the \"Apply\" button.  The new order will be applied to the running
system, but will not be saved as the permanent setting until a \"Save\" operation is selected from the main Config Tool menu.<br>\n";
	print "<img src=\"/images/config/bar.gif\"><br>";
    }

    print "<center>\n";
    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/change_rule.pl\">\n";
    print "<center>\n\n";

    print "<h3>Current Rule Order:</h3>\n";
    &disp_rules("MovePolicy", 0, 1);

    print "<table><tr>\n";
    print "<td align=right><b>Move rule : </b>\n";
    print "<td align=left>\n";
    &disp_nrlist("MoveRule", 2);
    print "<td align=right><b>Before rule : </b>\n";
    print "<td align=left>\n";
    &disp_nrlist("MoveBefore", 0);
    print "</tr></table>\n\n";

    print "<hr>\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"Move\" VALUE=\"OK\">\n";
    print "<INPUT TYPE=\"image\" SRC=\"/images/config/applybutton.gif\" BORDER=0>\n";
    print "</FORM>\n\n";
}


sub default_edit_params {
    print "<center>";
    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/change_rule.pl\">\n";
#   print "default_edit_params: flow_edit = $flow_edit. selectpolicy=$selectpolicy.<br>\n";
    if ($flow_edit eq "Edit") {
	print "<center>\n";
	print "<h3>Editing rule: <i>$selectpolicy</i></h3></caption>\n";
    }
    else {
#	print "<center><h3>Create New Rule For Policy <i>$mastertable</i></h3>\n";

	print "<h4>New Rule Name: <INPUT TYPE=\"text\" NAME=\"NewRule\" VALUE=\"$newrule\" SIZE=20></h4>\n";
    }

    print "<table>";
    if ($srcport eq "") { $srcport = "any"; }
    if ($dstport eq "") { $dstport = "any"; }
    if ($dst eq "") { $dst = "any"; }
    if ($src eq "") { $src = "any"; }
    if ($ipproto eq "") { $ipproto = "any"; }
    if ($interface eq "") { $interface = "any"; }

    print "<tr valign=middle>";
    print "<td align=right><b>Source/MaskLen: </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"Source\" VALUE=\"$src\" SIZE=25>\n";
    print "<td align=right><b>SPort/Mask: </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"SrcPort\" VALUE=\"$srcport\" SIZE=8>\n";
    print "</tr>\n";
    print "<tr valign=middle>\n";
    print "<td align=right><b>Dest/MaskLen: </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"Dest\" VALUE=\"$dst\" SIZE=25>\n";
    print "<td align=right><b>DPort/Mask: </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"DestPort\" VALUE=\"$dstport\" SIZE=8>\n";
    print "</tr>\n";

    if ($ihelp eq "on") {
	print "<font -= 2>\n";
	print "<tr><th colspan=4 align=left><img src=\"/images/config/helpbar.gif\"></tr>";
	print "<tr><td align=right valign=top>src/dst: <td align=left valign=top>aaa.bbb.ccc.ddd[/len]";
	print "<td align=right valign=top>sport/dport: <td aligh=left>number mask | service";
	print "</tr>";
	print "<tr><td><td align=left>a.b.c.d.x.y.z.w | any";
	print "</tr>\n";
	print "<tr><th colspan=4 align=left><img src=\"/images/config/bar.gif\"></tr>";
	print "<font += 2>\n";
    }

    print "<tr valign=middle>\n"; 
    print "<td align=right><b>Interface: </b>\n";
    print "<td align=left>\n";
    &disp_iflist($interface);
    if ($if_in eq "yes") {
	print "<td align=right><INPUT TYPE=\"checkbox\" NAME=\"InterfaceIn\" checked><b> Inbound</b>";
    }
    else {
	print "<td align=right><INPUT TYPE=\"checkbox\" NAME=\"InterfaceIn\"><b> Inbound</b>";
    }

    if ($if_out eq "yes") {
	print "<td align=left><INPUT TYPE=\"checkbox\" NAME=\"InterfaceOut\" checked><b> Outbound</b>";
    }
    else {
	print "<td align=left><INPUT TYPE=\"checkbox\" NAME=\"InterfaceOut\"><b> Outbound</b>";
    }
    print "</tr>\n";

    if ($ihelp eq "on") {
	print "<font -= 4>";
	print "<tr valign=middle>\n";
	print "<th colspan=4 align=left><img src=\"/images/config/helpbar.gif\"></th>";
	print "</tr><tr>\n";
	print "<td align=right>Inbound/Outbound: <td colspan=3><font -= 4>At least one of Inbound or Outbound must be associated for a rule to take effect."; 
	print "</tr><tr>\n";
	print "<th colspan=4 align=left><img src=\"/images/config/bar.gif\"></th>";
	print "<font += 4>";
    }

    print "<tr valign=middle>\n"; 
    print "<td align=right><b>IPproto: </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"IPproto\" VALUE=\"$ipproto\" SIZE=8>\n";
    print "</tr>\n";

    if ($ihelp eq "on") {
	print "<tr>";
	print "<th colspan=4 align=left><img src=\"/images/config/helpbar.gif\"></th>";
	print "</tr><tr>";
	print "<td align=right>IP protocol: <td>tcp | udp | number | any";
	print "</tr><tr>\n";
	print "<th colspan=4 align=left><img src=\"/images/config/bar.gif\"></th>";
    }
    print "</table>\n";

    print "<hr>\n";

    print "<center><table><h3>Actions for this rule:</h3>\n";
    print "<tr>\n";
    print "<td align=right><b>Filter: </b>";
    print "<td align=left>\n";
    &disp_filterlist($filter);
    print "<td>\n";
    print "<td align=right><b>Priority: </b>";
    print "<td align=left>\n";
    &disp_priolist("$priority");
    print "<td align=right><b>Forward: </b>";
    print "<td align=left>\n";
    &disp_swlist($switch_policy, 1);

    if ($ihelp eq "on") {
    	print "<tr valign=left>\n"; 
	print "<th colspan=6 align=left><img src=\"/images/config/helpbar.gif\"></th>";
	print "</tr><tr>";
	print "<td align=right valign=top>Priority: <td colspan=6 align=left>high|med|normal|low.  User can also choose numeric value for the priority field with number zero being the highest priority. \"high\" maps to the numeric value zero (0); \"med\" maps to value one (1); \"normal\" maps to value two (2); and \"low\" maps to value three (3).";
	print "</tr><tr>\n";
	print "<td align=right valign=top>Forward: <td colspan=6 align=left>User must select a forwarding rule if the filter attribute is not deny or drop silent.  Forwarding rules are configured in the active forwarding policy page.";
	print "</tr><tr>\n";
	print "<th colspan=6 align=left><img src=\"/images/config/bar.gif\"></th>";
    }

    print "</tr></table>\n";
    print "<hr>\n";

    #
    # Apply button should return to previous page.
    #
    print "<INPUT TYPE=\"hidden\" NAME=\"Action\" VALUE=\"Apply\">\n";
    print "<INPUT TYPE=\"image\" SRC=\"/images/config/applybutton.gif\" BORDER=0>\n";

    print "<INPUT TYPE=\"hidden\" NAME=\"SwitchPolicy\" VALUE=\"$switch_policy\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"FlowEdit\" VALUE=\"$flow_edit\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"SelectPolicy\" VALUE=\"$selectpolicy\">\n";

    print "</FORM>";
}


sub set_var {
    $ihelp = $GLOBAL{'IHelp'};
    if (!$ihelp) { 
	$ihelp = "off";  
	$nhelp = "on"; 
    } 
    elsif ($ihelp eq "off") { $nhelp = "on"; } else { $nhelp = "off"; }
    $advanced = $GLOBAL{'Advanced'};
    $action = $GLOBAL{'Action'};
    $move = $GLOBAL{'Move'};
    $editmode = $GLOBAL{'EditingMode'};
    $flow_edit = $GLOBAL{'FlowEdit'};
    $qplistsize = $GLOBAL{'PlistSize'};
    $newrule = $GLOBAL{'NewRule'};
    $applyrule = $GLOBAL{'ApplyRule'};

    $s = $GLOBAL{'SelectPolicy'};
    ($selectpolicy, $a) = split(' ', $s);

    if ($action eq "Select") {
	&PrintHeadToe("GOTO", "/cgi-bin/new_policy.pl");
	&PrintHeadToe("TRAILER");
    }
    elsif ($flow_edit eq "Delete") {
	&PrintHeadToe("GOTO", "/cgi-bin/qos.pl?Action=Delete&FlowEdit=$flow_edit&SelectPolicy=$selectpolicy");
	&PrintHeadToe("TRAILER");
    }
    elsif ($flow_edit eq "Move") {
	&PrintHeadToe("HEADER", 
	    "Move Rule within Policy",
	    "/conf/conf_view_qos3.html", 
	    "/cgi-bin/qos.pl", 
	    "/cgi-bin/change_rule.pl?IHelp=$nhelp&FlowEdit=$flow_edit",
	    "/cgi-bin/html_page?TEMPLATE=main");
    }
    else {
	&PrintHeadToe("HEADER", 
	    "Edit Rule for Policy",
	    "/conf/conf_view_qos3.html", 
	    "/cgi-bin/qos.pl", 
	    "/cgi-bin/change_rule.pl?IHelp=$nhelp&FlowEdit=$flow_edit",
	    "/cgi-bin/html_page?TEMPLATE=main");
    }
#print "Starting: ", &ctime(time), "<br>\n";

    #
    # we're applying moving a rule
    #
    if ($move eq "OK") {
      &get_data;
      &GetCurrentPolicy;
      &get_rules_from_current_policy;

      $movepolicy = $GLOBAL{'MoveRule'};
      $beforepolicy = $GLOBAL{'MoveBefore'};
      if ($movepolicy ne $beforepolicy) {
	$movepolicy = $GLOBAL{'MoveRule'};
	$beforepolicy = $GLOBAL{'MoveBefore'};
	$moveorder = &GetPolicyOrder("$mastertable", "$movepolicy");
	if ($beforepolicy eq "$IMPLICITSHORT") {
	    $beforepolicy = $beforeorder = "";
	    $afterpolicy = $PNAMELIST[$PNlistSize-1];
	    $afterorder = &GetPolicyOrder("$mastertable", "$afterpolicy");
	}
	else {
	    $beforeorder = &GetPolicyOrder("$mastertable", "$beforepolicy");
	}

	if ($beforeorder) {
	    $i = 0;
	    while ($i < $PlistSize && $PLIST[$i] != $beforeorder) {
	    	$i++;
	    }
	    $diff = ($beforeorder - $PLIST[$i-1])/2;
	    $new_order = $beforeorder - $diff;
	}
	else {	# moving to right before the implicit rule
	    $new_order = $afterorder + $INC;
	}
#print "movepolicy=$movepolicy, moveorder=$moveorder, beforepolicy=$beforepolicy, afterpolicy=$afterpolicy, afterorder=$afterorder. new_order=$new_order.<br>\n";

	@oldlines = grep(/^machine:$mname:policy:qostable:$mastertable:$moveorder/, @a);

	$newlines="\n\nmachine:$mname:policy:qostable:$mastertable:$moveorder\nmachine:$mname:policy:qostable:$mastertable:$moveorder:name\nmachine:$mname:policy:qostable:$mastertable:$moveorder:class\nmachine:$mname:policy:qostable:$mastertable:$moveorder:swt\nmachine:$mname:policy:qostable:$mastertable:$moveorder:filter\nmachine:$mname:policy:qostable:$mastertable:$moveorder:priority\nmachine:$mname:policy:qostable:$mastertable:$moveorder:rule\nmachine:$mname:policy:qostable:$mastertable:$new_order t\n";
	foreach $line (@oldlines) {
	    $newline = $line;
	    $newline =~ s/$moveorder/$new_order/g;
	    $newlines=$newlines.$newline;
	}

	$newline="\napply apply\n";
	$newlines=$newlines.$newline;
	&update_conf($newlines, 1);
	&get_new_policies;
	&get_clist;
        &GetCurrentPolicy;
        &get_rules_from_current_policy;
      }
      else {
	&get_clist;
      }

      $flow_edit = "Move";
      return;
    }

    &get_data;
    &GetCurrentPolicy;
    &get_rules_from_current_policy;
    &get_forwarding_rules;
    &get_interfaces;

    #
    # if $newrule is set then we came back from a new create apply
    #
    if ($newrule ne "") {
      if ($currorder eq "") {
	$currorder = 0;
	$currclass = 0;
	$policy_order = 1000;
      }
      else {
	$currorder = &GetPolicyOrder("$mastertable", "$selectpolicy");
	$policy_order = &GetNewPolicyOrder("$mastertable", "$currorder");
	$currclass = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$currorder:class");
#print "set_var: selectpolicy=$selectpolicy, currorder=$currorder, policy_order=$policy_order.<br>\n";
      }

      $duplicate = &GetPolicyOrder($mastertable, $newrule);
      if (!$duplicate) {
	  $newcreate = 1;
	  $class = "$mastertable-$newrule";
      }
      else {
#print "duplicate=$duplicate, mastertable=$mastertable, newrule=$newrule.<br>\n";
      }
      $policy = $newrule;
    }
    else {
      if ($action eq "Apply" && $newrule eq "" && 
		($flow_edit eq "Create" || $flow_edit eq "Copy")) {
	print "<img src=\"/images/config/errorbar.gif\"><br>\n";
        print "You did not enter a rule name.<br>\n";
	print "<img src=\"/images/config/redbar.gif\"><br>\n";
	$flow_edit = "Create";
	$no_name = 1;
      }
      elsif ($action eq "Apply" && $newfule eq "" && $flow_edit eq "ReEdit") {
	print "<img src=\"/images/config/errorbar.gif\"><br>\n";
        print "You did not enter a rule name.<br>\n";
	print "<img src=\"/images/config/redbar.gif\"><br>\n";
	$flow_edit = "ReEdit";
	$no_name = 1;
      }
      else {
	$newcreate = 0;
        if ($currorder) {
	    $policy_order = $currorder;
            $class = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$policy_order:class");
        }
	else {
	    $policy_order = &GetNewPolicyOrder("$mastertable", "$currorder");
	}
      }
      $policy = $selectpolicy;
    }

    #
    # action = Apply could be from edit or create new
    #
    if ($action eq "Apply") {
      $if_in = $GLOBAL{'InterfaceIn'};
      if ($if_in eq "on") { 
	$if_in = "yes"; 
      }
      else {
	$if_in = "no"; 
      }

      $if_out = $GLOBAL{'InterfaceOut'};
      if ($if_out eq "on") { 
	$if_out = "yes"; 
      }
      else {
	$if_out = "no"; 
      }

      $interface = $GLOBAL{'Interface'};
      $ipproto = $GLOBAL{'IPproto'};
      $dst = $GLOBAL{'Dest'};
      $dstport = $GLOBAL{'DestPort'};
      $src = $GLOBAL{'Source'};
      $srcport = $GLOBAL{'SrcPort'};
      $filter = $GLOBAL{'FilterSelect'};
      $priority = $GLOBAL{'PrioSelect'};
      $switch_policy = $GLOBAL{'SWSelect'};
      if ($srcport eq "") { $srcport = "any"; }
      if ($dstport eq "") { $dstport = "any"; }
      if ($dst eq "") { $dst = "any"; }
      if ($src eq "") { $src = "any"; }
      if ($ipproto eq "") { $ipproto = "any"; }
      if ($interface eq "") { $interface = "any"; }
      if ($switch_policy eq "") { $switch_policy = "switch"; }

      if ($duplicate && ($flow_edit eq "Create" || $flow_edit eq "Copy")) {
	print "<img src=\"/images/config/errorbar.gif\"><br>\n";
	print "You have entered a duplicate rule name, $newrule.<br>\n";
	print "<img src=\"/images/config/redbar.gif\"><br>\n";
	$flow_edit = "Create";
      }
      elsif ($no_name ne "1") {
        #
        # we're applying changes
        #
	$newlines="\n\nmachine:$mname:policy:class t\nmachine:$mname:policy:class:$mastertable-$policy t\nmachine:$mname:policy:class:$mastertable-$policy:src $src\nmachine:$mname:policy:class:$mastertable-$policy:dst $dst\nmachine:$mname:policy:class:$mastertable-$policy:srcport $srcport\nmachine:$mname:policy:class:$mastertable-$policy:dstport $dstport\nmachine:$mname:policy:class:$mastertable-$policy:ipproto $ipproto\nmachine:$mname:policy:class:$mastertable-$policy:interface $interface\nmachine:$mname:policy:class:$mastertable-$policy:inbound $if_in\nmachine:$mname:policy:class:$mastertable-$policy:outbound $if_out\nmachine:$mname:policy:qostable:$mastertable t\nmachine:$mname:policy:qostable:$mastertable:$policy_order t\nmachine:$mname:policy:qostable:$mastertable:$policy_order:name $policy\nmachine:$mname:policy:qostable:$mastertable:$policy_order:class $mastertable-$policy\nmachine:$mname:policy:qostable:$mastertable:$policy_order:swt $switch_policy\nmachine:$mname:policy:qostable:$mastertable:$policy_order:filter $filter\nmachine:$mname:policy:qostable:$mastertable:$policy_order:priority $priority\napply apply\n";

	&update_conf($newlines, 1);

	if (!@err_messages) {
	  if ($flow_edit ne "Edit") {
	    $flow_edit = "Edit";
	    &update_conf("\n\nmachine:$mname:policy:qostable:control:edit:rule $policy\napply apply\n", 0);
	    &get_new_policies;
	    $selectpolicy = $policy;
	    &get_clist;
	    &get_ipproto_list;
	    &GetCurrentPolicy;
	    &get_rules_from_current_policy;
	  }
	}
      }
    }
    else {
      #
      # we've came in not from a apply, i.e. first time into the edit page
      # or re-edit from somewhere else.
      #
      if ($flow_edit eq "ReEdit") {
	$interface = $GLOBAL{'Interface'};
	$if_in = $GLOBAL{'InterfaceIn'};
	$if_out = $GLOBAL{'InterfaceOut'};
	$ipproto = $GLOBAL{'IPproto'};
	$dst = $GLOBAL{'Dest'};
	$dstport = $GLOBAL{'DestPort'};
	$src = $GLOBAL{'Src'};
	$srcport = $GLOBAL{'SrcPort'};
	$filter = $GLOBAL{'FilterSelect'};
	$priority = $GLOBAL{'PrioSelect'};
	$switch_policy = $GLOBAL{'SWSelect'};
      }
      elsif ($flow_edit eq "Create") {
	$src = "";
	$srcport = "";
	$dst = "";
	$dstport = "";
	$interface = "";
	$if_in = "";
	$if_out = "";
	$ipproto = "";
	$filter = "";
	$priority = "";
	$switch_policy = "switch";
      }
      else {
	#
	# must be first time into the edit page.
	#
	@current_class = grep(/machine:$mname:policy:class:$class:/, @a);
	$switch_policy = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$policy_order:swt");

	$interface = &GetClassValue("machine:$mname:policy:class:$class:interface");
	$if_in = &GetClassValue("machine:$mname:policy:class:$class:inbound");
	$if_out = &GetClassValue("machine:$mname:policy:class:$class:outbound");
	$ipproto = &GetClassValue("machine:$mname:policy:class:$class:ipproto");
	$dst = &GetClassValue("machine:$mname:policy:class:$class:dst ");
	$dstport = &GetClassValue("machine:$mname:policy:class:$class:dstport");
	$src = &GetClassValue("machine:$mname:policy:class:$class:src ");
	$srcport = &GetClassValue("machine:$mname:policy:class:$class:srcport");
	$filter = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$policy_order:filter");
	$priority = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$policy_order:priority");

	if ($flow_edit eq "") {
	    $flow_edit = "Edit";
	}
      }
      &get_clist;
      &get_ipproto_list;
#      &GetCurrentPolicy;
#      &get_rules_from_current_policy;
    }
}
