#!/usr/bin/perl
#
$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";
$TMPLDIR= "/usr/local/monitor/templates";

push(@INC, "$CGIDIR");
require 'mon-lib.pl';
require 'info-lib.pl';
require 'sysctl-lib.pl';

&GetIpsInfo();
&GetTypeSpecific();

&ParseSysctl("ips.system.stats.flow");

&PrintIPSHeader || return;
&Form();
&PrintButtonBar("TRAILER");

sub	PrintIPSHeader {
    if ($IPSDEVTYPE eq "controller") { 
	&PrintButtonBar("HEADER", "Flow Statistics"); 
    } elsif ($IPSDEVTYPE eq "gateway") {
	&PrintButtonBar("HEADER", "No Flow View Available"); 
	&PrintButtonBar("TRAILER");
	return 0;
    } else {
	&PrintButtonBar("HEADER", "Flow Statistics"); 
    }
    return 1;
}

sub Form {
	local($tmpl) = "$TMPLDIR/flow_state.tmpl";
	local($s);
	local($_);

	if(!open(READTMPL, $tmpl))
		{ &PrintMsgHdr("Can't open $tmpl: $!"); return 1; }
	while (<READTMPL>) {
		if (/@(\S*)@/)
			{ $_= &MapTempVal($1,$_,$countNum); }
		print "$_";
	}
	close(READTMPL);
}

sub MapTempVal {
local($mSub,$line,$index) = @_; 
local($s) = &$mSub($index);

	$line =~ s/@$mSub@/$s/; return $line; 
}

sub GetUniFlow
	{ return ($ips_data{"ips.system.stats.flow.unicast"}); }

sub GetMultiFlow
	{ return ($ips_data{"ips.system.stats.flow.multicast"}); }

sub GetTransX0
	{ return ($ips_data{"ips.system.stats.flow.state_transition_X0"}); }

sub GetTrans0Y
	{ return ($ips_data{"ips.system.stats.flow.state_transition_0Y"}); }

sub GetTransXY
	{ return ($ips_data{"ips.system.stats.flow.state_transition_XY"}); }

sub GetTrans00
	{ return ($ips_data{"ips.system.stats.flow.state_transition_00"}); }

sub GetTotalFlowTrans
	{ return ($ips_data{"ips.system.stats.flow.state_transition_00"} +
		  $ips_data{"ips.system.stats.flow.state_transition_XY"} +
		  $ips_data{"ips.system.stats.flow.state_transition_0Y"} +
		  $ips_data{"ips.system.stats.flow.state_transition_X0"}); }

sub GetNoVCI
	{ return ($ips_data{"ips.system.stats.flow.no_vci"}); }

sub GetLifeGt30s
	{ return ($ips_data{"ips.system.stats.flow.avg_liftetime_>_30s"}); }

sub GetLifeLt30s
	{ return ($ips_data{"ips.system.stats.flow.avg_lifetime_<_30s"}); }

