#!/usr/bin/perl

# $ID$

    push (@INC, "/usr/local/www/cgi-bin");
    require 'qos-lib.pl';

    &ReadInput(*INPUT);
    &ParseData(*GLOBAL, $INPUT);
    &set_var;
    &display_help;

    if ($action eq "Create") {
	    &disp_list;
	    &edit_params;
    }
    else  {
	    &disp_list;
	    &edit_params;
    }

    &PrintHeadToe("TRAILER", 
	"", 
	"/conf/conf_view_qos4.html", 
	"/cgi-bin/qos.pl", 
	"/cgi-bin/forward.pl?IHelp=$nhelp",
	"/cgi-bin/html_page?TEMPLATE=main");


################################################

sub display_help {
 if ($ihelp eq "on") {
    print "<img src=\"/images/config/helpbar.gif\"><br>\n";
    print "<font -= 2>\n";
    print "Forwarding rule is used by IP switch controller and gateways to determine how to use the various levels of forwarding performance in IP switch architecture.<br><br>\n";
    print "There are three default forwarding rules: switch, forward and cache.  You may create your own forwarding rules by either creating from new, or copy one of these default rules.  Please keep in mind that changes to a forwarding rule will have impact to the rules in QoS policies that use it; deleting a forwarding rule that is currently being used by rule(s) in QoS policies will generate an error message of \"No such rule or policy\".<br>\n";
    print "<br>To edit a forwarding rule, select one from the rule list and click on the \"Select\" button, attributes for the select rule will be displayed at the lower half of the screen.  You may also select one of the other editing functions: Copy, Create and Delete.<br>\n";
    print "<img src=\"/images/config/bar.gif\"><br>";
  }
}

sub disp_list {
    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/forward.pl\">";
    print "<center><table>\n";
    print "<tr>\n";
    print "<td valign=middle align=right><b>Forwarding Rules: </b>\n";
    print "<td align=left>\n";
    &disp_swlist($selectswitch);
    print "</tr></table>\n";
    print "<table><tr>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Select\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Copy\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Create\"></h5>\n";
    print "<td><h5><INPUT TYPE=\"submit\" NAME=\"Action\" VALUE=\"Delete\"></h5>\n";
    print "</tr>";
    print "</table><hr></center></FORM>\n";

}

sub edit_params {
    print "<FORM METHOD=\"POST\" ACTION=\"/cgi-bin/forward.pl\">";
    print "<center><table>\n";
    if ($action eq "Create" || $action eq "Copy") {
	print "<b>Forwarding Rule Name: </b><INPUT TYPE=\"text\" NAME=\"NewSwitch\" SIZE=20>\n";
    }
    else {
	print "<h3>Forwarding Rule Parameters for <i>$selectswitch</i>: </h3>\n";
    }

    print "<tr align=center>\n";
    print "<td align=right><b>Forward Option: </b>";
    print "<td align=left>";
    &disp_fwdoption($fwdoption);
    print "<td align=right><b>Encapsulation: </b>";
    print "<td align=left>";
    &disp_fplist($flowproto);
    print "</tr>\n";

    if ($ihelp eq "on") {
	print "<tr align=center>\n";
	print "<td colspan=4 align=left><img src=\"/images/config/helpbar.gif\"></tr>\n";
	print "<tr>\n";
	print "<td align=right valign=top>Forward Option: <td colspan=3 align=left>\"cache\" means that the first packet is processed by IP switch equipments and a state is created which caches the result of the route lookup and policy in the IP switch controller after this packet is forwarded.  Subsequent packets that match the cached state will follow the same decision stored in the cached state.\n";
	print "</tr><tr>\n";
	print "<td align=right valign=top>Encapsulation: <td colspan=3 align=left>Standard encapsulation is defined in RFC 1954 Type 2 flow; and Extended encapsulation is defined in RFC 1954 Type 1 flow.\n";
	print "</tr><tr>\n";
	print "<td colspan=4 align=left><img src=\"/images/config/bar.gif\"></tr>\n";
    }

    print "<tr align=center>\n";
    print "<td align=right><b>Wait Packets: </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"WaitPacket\" VALUE=\"$waitpacket\" SIZE=10>\n";

    print "<td align=right><b>Refresh Timer (+20sec): </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"RefreshTimer\" VALUE=\"$refreshtimer\" SIZE=5>\n";
    print "</tr>\n";

    if ($ihelp eq "on") {
	print "<tr align=left>\n";
	print "<td colspan=4><img src=\"/images/config/helpbar.gif\"></tr>\n";
	print "<tr>\n";
	print "<td align=right valign=top>Wait Packets: <td colspan=3 align=left>If a flow is eligible to use hardware accelerator, \"wait packet\" further defines when should the hardware accelerator be used for a flow. E.g., if the wait packet is 10, IP switch controller will not attempt to use the hardware accelerator unless at least 10 packets has been forwarded for the flow.\n";
	print "</tr><tr>\n";
	print "<td align=right valign=top>Refresh Timer: <td colspan=3 align=left>specifies how often the wait packet conditions should be rechecked for eligibility to use the hardware accelerator.  E.g., if RefreshTimer is 20 seconds, to be eligible for using hardware accelerator, a flow must have transmitted more than \"wait packet\" number of packets in at least one 20 seconds time intervals. This timer can be incremented in 20 seconds interval.\n";
	print "</tr><tr>\n";
	print "<td colspan=4><img src=\"/images/config/bar.gif\"></tr>\n";
    }

    print "<tr>\n";
    print "<td align=right><b>Idle Timer (+10sec): </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"IdleTimer\" VALUE=\"$idletimer\" SIZE=3>\n";
    print "<td align=right><b>Hold Timer (+10sec): </b>";
    print "<td align=left><INPUT TYPE=\"text\" NAME=\"HoldTimer\" VALUE=\"$holdtimer\" SIZE=5>\n";
    print "</tr>";

    if ($ihelp eq "on") {
	print "<tr align=left>\n";
	print "<td colspan=4><img src=\"/images/config/helpbar.gif\"></tr>\n";
	print "<tr>\n";
	print "<td align=right valign=top>Idle Timer: <td colspan=3 align=left>Once a flow exists longer than the HoldTimer, the flow will not be deleted until IdleTimer is satisfied.  IdleTimer is the time interval between current time and the last time a packet is forwarded.  IdleTimer can be incremented in 20 seconds interval.\n";
	print "</tr><tr>\n";
	print "<td align=right valign=top>Hold Timer: <td colspan=3 align=left>Once a flow is cached, its state will not be deleted until HoldTimer is satisfied. HoldTimer is the time interval between the first packet of a flow arrives at the IP switch controller and the current time.  This timer can be incremented in 10 seconds interval.\n";
	print "</tr><tr>\n";
	print "<td colspan=4><img src=\"/images/config/bar.gif\"></tr>\n";
    }

    print "</table></center><br>\n";
    print "<hr>\n";
    print "<center>\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"Edit\" VALUE=\"Apply\">\n";
    print "<INPUT TYPE=\"image\" SRC=\"/images/config/applybutton.gif\" BORDER=0 >\n";
   
    print "<INPUT TYPE=\"hidden\" NAME=\"SWSelect\" VALUE=\"$selectswitch\">\n";
    print "</FORM>\n";
}


sub set_var {
    $ihelp = $GLOBAL{'IHelp'};
    if (!$ihelp) {
	$ihelp = "off";
	$nhelp = "on";
    }
    elsif ($ihelp eq "off") { $nhelp = "on"; } else { $nhelp = "off"; }

    &PrintHeadToe("HEADER", 
	"Forwarding Rule Editing", 
	"/conf/conf_view_qos4.html", 
	"/cgi-bin/html_page?TEMPLATE=main",
	"/cgi-bin/forward.pl?IHelp=$nhelp",
	"/cgi-bin/html_page?TEMPLATE=main");

    &get_data;
    &get_forwarding_rules;

    $action = $GLOBAL{'Action'};
    $edit = $GLOBAL{'Edit'};
    $proceed = $GLOBAL{'Proceed'};
    $newswitch = $GLOBAL{'NewSwitch'};
    $selectswitch = $GLOBAL{'SWSelect'};
    if ($selectswitch eq "") {
	$selectswitch = $FORWARDLIST[0];
    }

#print "action=$action. proceed=$proceed. edit=$edit.<br>\n";
#print "edit=$edit, selectswitch=$selectswitch, newswitch=$newswitch.<br>";

    if ($action eq "Create") {
	$fwdoption = "switch";
	$flowproto = "";
	$waitpacket = "";
	$idletimer = "64";
	$holdtimer = "";
	$refreshtimer = "";
    }
    elsif ($edit eq "Apply") {
	$fwdoption = $GLOBAL{'FwdOption'};
	$flowproto = $GLOBAL{'FlowProto'};
	$waitpacket = $GLOBAL{'WaitPacket'};
	$idletimer = $GLOBAL{'IdleTimer'};
	$holdtimer = $GLOBAL{'HoldTimer'};
	$refreshtimer = $GLOBAL{'RefreshTimer'};
#print "applying, getting values from passed in...<br>";
#print "fwdoption=$fwdoption, flowproto=$flowproto, waitpacket=$waitpacket, idletimer=$idletimer, holdtimer=$holdtimer, refreshtimer=$refreshtimer.<br>";
    }
    else {
	$fwdoption = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:fo", 5);
	$flowproto = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:fp", 5);
	$waitpacket = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:wp", 5);
	$idletimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:it", 5);
	$holdtimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:ht", 5);
	$refreshtimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:rt", 5);
#print "fwdoption=$fwdoption, flowproto=$flowproto, waitpacket=$waitpacket, idletimer=$idletimer, holdtimer=$holdtimer, refreshtimer=$refreshtimer.<br>";
    }
 
    #
    # if proceed is OK then we're deleting for real this time
    #
    if ($action eq "Delete") {
	&update_conf("\n\nmachine:$mname:policy:swt\n\nmachine:$mname:policy:swt:$selectswitch\n\nmachine:$mname:policy:swt:$selectswitch:fp\n\nmachine:$mname:policy:swt:$selectswitch:fo\n\nmachine:$mname:policy:swt:$selectswitch:wp\n\nmachine:$mname:policy:swt:$selectswitch:it\n\nmachine:$mname:policy:swt:$selectswitch:ht\n\nmachine:$mname:policy:swt:$selectswitch:rt\napply apply\n", 1);

	&get_forwarding_rules;
	$selectswitch = $FORWARDLIST[0];
	$flowproto = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:fp", 5);
	$fwdoption = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:fo", 5);
	$waitpacket = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:wp", 5);
	$idletimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:it", 5);
	$holdtimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:ht", 5);
	$refreshtimer = &GetIndexedValue("machine:$mname:policy:swt:$selectswitch:rt", 5);
    }

    #
    # if edit is Apply then we're applying the changes for real this time
    #
    if ($edit ne "") {
#print "edit=$edit, newswitch=$newswitch, selectswitch=$selectswitch.<br>";
      if ($newswitch ne "") {
	$selectswitch = $newswitch;
      }

#      if ($flowproto eq "") {$flowproto = "any"};
      if ($fwdoption eq "") {$fwdoption = "switch"};
#      if ($waitpacket eq "") {$waitpacket = "any"};
      if ($idletimer eq "") {$idletimer = "64"};
#      if ($holdtimer eq "") {$holdtimer = "any"};
#      if ($refreshtimer eq "") {$refreshtimer = "any"};

      if ($edit eq "Apply") {
	&update_conf("\n\nmachine:$mname:policy:swt t\n\nmachine:$mname:policy:swt:$selectswitch t\nmachine:$mname:policy:swt:$selectswitch:fp $flowproto\nmachine:$mname:policy:swt:$selectswitch:fo $fwdoption\nmachine:$mname:policy:swt:$selectswitch:wp $waitpacket\nmachine:$mname:policy:swt:$selectswitch:it $idletimer\nmachine:$mname:policy:swt:$selectswitch:ht $holdtimer\nmachine:$mname:policy:swt:$selectswitch:rt $refreshtimer\napply apply\n", 1);

      }

      &get_forwarding_rules;
    }
}

