#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################
#
$WEBDIR         = "/usr/local/www";
$CGIDIR         = "$WEBDIR/cgi-bin";
#
sub layoutSystem {
	local(*a) = @_;
	local($currY, $x, $y) = (0, $a{"layout.system.x"}, $a{"layout.system.y"});

	&canvasOpen($a{"layout.system.width"}, $a{"layout.system.height"});
	#
	for ($chasNum =1; $chasNum <= $a{"system.chasNumber"}; $chasNum++) {
		$chasType = $a{"system.chassis.$chasNum.type"};
		&layoutChassis(*a, $chasNum, $chasType, $x, $y);
		$y += $a{"layout.chassis.$chasType.image.height"};
	}
	#
	&canvasClose;
}

sub layoutChassis {
	local(*a, $chasN, $chasT, $x, $y) = @_;
	local($locX, $locY) = ($x + $a{"layout.chassis.$chasT.x"}, $y + $a{"layout.chassis.$chasT.y"});
	
	&canvasCreateBitmap($locX, $locY, $a{"layout.chassis.$chasT.image"});
	#
	$slotNumber = $a{"component.chassis.$chasT.slotNumber"};
	for ($slotNum = 1; $slotNum <= $slotNumber; $slotNum++) {
		$cardType = $a{"system.chassis.$chasN.slot.$slotNum.cardType"};
		&layoutCard(*a, $chasN, $chasT, $slotNum, $cardType, $locX, $locY);
	}
}

sub layoutCard {
	local(*a, $chasN, $chasT, $slotN, $cardT, $x, $y) = @_;
	local($locX, $locY) = ($x + $a{"layout.chassis.$chasT.slot.$slotN.x"},
			       $y + $a{"layout.chassis.$chasT.slot.$slotN.y"});

	&canvasCreateBitmap($locX, $locY, $a{"layout.card.$chasT.$cardT.image"});
	#
	if ($cardT eq "slot")
		{ return; }
	$portNumber = $a{"component.card.$chasT.$cardT.portNumber"};
	for ($portNum = 1; $portNum <= $portNumber; $portNum++)
		{ &layoutPort(*a, $chasN, $chasT, $slotN, $cardT, $portNum, $locX, $locY); }
}

sub layoutPort {
	local(*a, $chasN, $chasT, $slotN, $cardT, $portN, $x, $y) = @_;
	local($locX, $locY) = ($x + $a{"layout.card.$chasT.$cardT.port.$portN.x"},
			       $y + $a{"layout.card.$chasT.$cardT.port.$portN.y"});

	$statusType = $a{"system.chassis.$chasN.slot.$slotN.port.$portN.status"};
	&canvasCreateBitmap($locX, $locY, $a{"layout.port.status.$statusType.image"});
}

1;
