#!/usr/bin/perl
#
$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";
$TMPLDIR= "/usr/local/monitor/templates";

$ATMLTMPL       = "$TEMPLDIR/atml.tmpl";
$SPINOLITMPL    = "$TEMPLDIR/spinoli.tmpl";
$DECTMPL        = "$TEMPLDIR/dec.tmpl";
$IPSWGWTMPL     = "$TEMPLDIR/ipswgw.tmpl";
$PORTTMPL       = "$TEMPLDIR/port_layout.tmpl";

$IPSDEVTYPE     = "controller";
$IPSSWITCHTYPE  = "SPINOLI";

$ips_far        = "NONE"; 
$switch_tmpl    = "$SPINOLITMPL";
$port_tmpl      = "$PORTTMPL";

push(@INC, "$CGIDIR");

require 'mon-lib.pl';
require 'info-lib.pl';
require 'sysctl-lib.pl';

&ReadInput(*INPUT);
&ParseData(*GLOBAL, $INPUT);
if($ENV{'PATH_INFO'}) {
	if ($ENV{'PATH_INFO'} =~ /^\/(\S*)\/(\S*)/)
		{ $portname = $1; $logicalname = $2 }
}

&GetIpsInfo;
&GetTypeSpecific;

&PrintButtonBar("HEADER", "Port View: $portname");
&Form;
&PrintButtonBar("TRAILER");


sub Form {
	local($tmpl) = "$TMPLDIR/port.tmpl";
	local($_);

	if(!open(READTMPL, $tmpl))
		{ &PrintMsgHdr("Can't open $tmpl: $!"); return 1; }
	while (<READTMPL>) {
		if (/@(\S*)@/)
			{ $_= &MapTempVal($1,$_,$portname); }
		print "$_";
	}
	close(READTMPL);
}

sub MapTempVal {
local($mSub,$line,$index) = @_; 
local($s) = &$mSub($index);

	$line =~ s/@$mSub@/$s/; return $line; 
}

sub ICells {
	 return "NA";
}

sub OCells {
	 return "NA";
}

sub IPackets {
        local ($ifnum) = @_;

        if ($ifnum) {
                if (!($ips_data{"if$ifnum.ipackets"} eq ""))
                        { return $ips_data{"if$ifnum.ipackets"}; }
        }
        else {  
                if (!($nic_data{"if$ips_far.ipackets"} eq ""))
                        { return $nic_data{"if$ips_far.ipackets"}; }
        }       
        return "NA";
}

sub OPackets {
        local ($ifnum) = @_;

        if ($ifnum) {
                if (!($ips_data{"if$ifnum.opackets"} eq ""))
                        { return $ips_data{"if$ifnum.opackets"}; }
        }
        else {  
                if (!($nic_data{"if$ips_far.opackets"} eq ""))
                        { return $nic_data{"if$ips_far.opackets"}; }
        }       
        return "NA";
}

sub OBytes {
        local ($ifnum) = @_;

        if ($ifnum) {
                if (!($ips_data{"if$ifnum.obytes"} eq ""))
                        { return $ips_data{"if$ifnum.obytes"}; }
        }
        else {  
                if (!($nic_data{"if$ips_far.obytes"} eq ""))
                        { return $nic_data{"if$ips_far.obytes"}; }
        }       
        return "NA";
}

sub IBytes {
        local ($ifnum) = @_;

        if ($ifnum) {
                if (!($ips_data{"if$ifnum.ibytes"} eq ""))
                        { return $ips_data{"if$ifnum.ibytes"}; }
        }
        else {  
                if (!($nic_data{"if$ips_far.ibytes"} eq ""))
                        { return $nic_data{"if$ips_far.ibytes"}; }
        }       
        return "NA";
}

sub Physical {
        local ($ifnum) = @_;

        if ($ifnum) {
                if ($ips_data{"if$ifnum.physical"})
                        { return $ips_data{"if$ifnum.physical"}; }
        }
        else {  
                if ($nic_data{"if$ips_far.physical"})
                        { return $nic_data{"if$ips_far.physical"}; }
        }       
        return "NA";
}

sub LastChange {
        local ($ifnum) = @_;

        if ($ifnum) {
                if ($ips_data{"if$ifnum.lastchange"})
                        { return $ips_data{"if$ifnum.lastchange"}; }
        }
        else {  
                if ($nic_data{"if$ips_far.lastchange"})
                        { return $nic_data{"if$ips_far.lastchange"}; }
        }       
        return "NA";
}

sub MTU {
        local ($ifnum) = @_;

        if ($ifnum) {
                if ($ips_data{"if$ifnum.mtu"})
                        { return $ips_data{"if$ifnum.mtu"}; }
        }
        else {  
                if ($nic_data{"if$ips_far.mtu"})
                        { return $nic_data{"if$ips_far.mtu"}; }
        }       
        return "NA";
}

sub LogicalName {
        local ($ifnum) = @_;

        if ($ifnum) {
                if ($ips_data{"if$ifnum.name"})
                        { return $ips_data{"if$ifnum.name"}; }
        }
        else {  
                if ($nic_data{"if$ips_far.name"})
                        { return $nic_data{"if$ips_far.name"}; }
        }       
        return "NONE";
}

sub IPv4 {
        local ($ifnum) = @_;
   
        if ($ifnum) {
                if ($ips_data{"if$ifnum.addrs[1].addrs"} =~ /IFA/) {
                        if  ($ips_data{"if$ifnum.addrs[1].address"})
                                { return $ips_data{"if$ifnum.addrs[1].address"}; }
                }
        }
        else {
                if ($nic_data{"if$ips_far.addrs[1].addrs"} =~ /IFA/) {
                        if  ($nic_data{"if$ips_far.addrs[1].address"})
                                { return $nic_data{"if$ips_far.addrs[1].address"}; }
                }
        }
        return "NONE";
}

sub Admin  {
        local ($ifnum) = @_;

        if ($ifnum) {
                if ($ips_data{"if$ifnum.flags"}) {
                        if ($ips_data{"if$ifnum.flags"} =~ /UP/)
                                { return "UP"; }
                }
        }
        else {
                if ($nic_data{"if$ifnum.flags"}) {
                        if ($nic_data{"if$ifnum.flags"} =~ /UP/)
                                { return "UP"; }
                }
        }
        return "DOWN";
}

sub RemoteIP {
        local ($ifnum) = @_;

        if ($ifnum) {
                if ($ips_data{"if$ifnum.addrs[1].addrs"} =~ /IFA/) {
                        if ($ips_data{"if$ifnum.addrs[1].broadcast"})
                                { return $ips_data{"if$ifnum.addrs[1].broadcast"}; }
                }
        }       
        else {          
                if ($nic_data{"if$ifnum.addrs[1].addrs"} =~ /IFA/) {
                        if ($nic_data{"if$ifnum.addrs[1].broadcast"})
                                { return $nic_data{"if$ifnum.addrs[1].broadcast"}; }
                }
        }
        return "NONE";
}

sub ImageUp  {
        local ($ifnum) = @_;
        local ($tmp);

        if ($ifnum) {
                if (!(($tmp = $ips_data{"if$ifnum.ifindex"}) eq "")) {
                        if (!(($tmp = $ips_data{"tool.iflist_to_if[$tmp]"}) eq "")) {
                                if (!(($tmp = $ips_data{"ips.if[$tmp].operstatus"}) eq "")) {
                                        if ($tmp eq 1)
                                                { return "UP"; }
                                        else
                                                { return "DOWN"; }
                                }
                        }
                }
        }
        else {
		if (&SwitchImageUp($ifnum) eq "/images/green.gif")
			{ return "UP"; }
		return "DOWN";
	}
        return "NA";
}

sub GetFarSideImage     {
        local($remoteip) = @_;
        local($img_ipswgw) = "IPSwitch Gateway";
        local($img_ipsw) = "IPSwitch";
        local($img) = "NA";
        local($_);

        $SIG{"ALRM"} = "GFSIAlrmHandler"; alarm(1);
# @@ What the hell is this
#        $pidSNMP = open(READSNMP, "$CGIDIR/bin/getone $remoteip public sysObjectID.0 2>&1 |");

        while (<READSNMP>) {
                if (/1561.\d*.\d*.(\d*).0/) {
                        if ($1 eq 1)
                                { $img = $img_ipsw; }
                        elsif ($1 eq 2)
                                { $img = $img_ipswgw; }
                }
                else {
                        if (/ipSwitchReg.0$/)
                                { $img = $img_ipsw; }
                        elsif (/ipSwGatewayReg.0$/)
                                { $img = $img_ipswgw; }
                        }
        }
        close(READSNMP); return $img;
}

sub GFSIAlrmHandler {
        $SIG{"ALRM"} = "DEFAULT";
        kill (1, $pidSNMP, $pidSNMP+1);
        return;
}

