#!/usr/bin/perl

$DSAVE = "/usr/local/www/cgi-bin/dsave";
$ListSize = 10;
$INC = 1000;
#$IMPLICITLONG = "--------------Implicit Rule (Accept)--------------";
$IMPLICITLONG = "______________________________________Implicit Rule (Accept)______________________________________";
$IMPLICITSHORT = "Implicit Rule";
@FILTERLIST = ("permit", "deny", "drop silent");
@PIORLIST = ("high", "med", "normal", "low");
@FLOWPLIST = ("standard", "extended");
@FWDOPTION = ("switch", "cache", "forward");
@SERVICES = ("http (80)", "ftp-data (20)", "ftp (21)", "telnet (23)");
@HOSTS = ("foo.ipsilon.com", "ftp-server", "www.netscape.com");

  require "flush.pl";
  require "ctime.pl";


#
# Read input sent by browser to cgi program.
# This routine reads the input received via the web GET or POST method
# and returns the input in the variable: $input.
# Call with:
#	&ReadInput(*input);
#
sub ReadInput {
  local(*input) = @_;
  local($len);

  if ($ENV{'REQUEST_METHOD'} eq "GET") {
        $input = $ENV{'QUERY_STRING'};      	# Using GET
  }
  else {
        $len = $ENV{'CONTENT_LENGTH'};       # Using POST
        if ($len > "34000") {                # Input size should never be absurd
                die "input buffer overflow, stopped";
        }
	read(STDIN, $input, $len);

  }
  return length($input);
}

#
# This routine takes the input string in $input, parses it into 
# name/value pairs and puts the result into the *nvarray associative array.
# Call with:
#	&ParseData(*nvarray, $input);
#
sub ParseData {
  local(*nvarray, $input) = @_;
  local($name, $value);
  local($i);

  @nvarray = split(/&/, $input);

  foreach $i (0 .. $#nvarray)
  {     
	$nvarray[$i] =~ s/\+/ /g;

	# Split on the first '='
        ($name, $value) = split(/=/, $nvarray[$i],2);

	# Translate web-special chars (i.e. international) into unsigned char.
        $name =~ s/%(..)/pack("C",hex($1))/eg;
        $value =~ s/%(..)/pack("C",hex($1))/eg;
        
        # Store name=value pair
	if (defined($nvarray{$name})) {
		$nvarray{$name} .= "\0";
	}
        $nvarray{$name} .= $value;
       print "Name: $name, Value: $value\n";
  }     
}

sub get {
  local($thing) = @_;
  open (FD, "/usr/local/config/bin/dbget $thing |");
  $result=<FD>;
  close(FD);
  chop($result);
  return($result);
}

# 
# Print out web page header or trailer for the Configuration Tool
# Call with:
#	&PrintHeadToe("HEADER", "TitleString");
# or
#	&PrintHeadToe("TRAILER", "BackPage");
#
# The HEADER call will print out the button bar with the Digital logo
# in the middle.  It also displays the "TitleString" on the page with:
# 	<title>TitleString</title>
# The TRAILER Call will have
#	link to qos main page
#	and a link to $BackPage
#
sub PrintHeadToe {
  local($type, $msg, $doc, $up, $help_page, $top) = @_;
  local($row, $i);
  local($fnprefix, $fnpostfix);
  local($numbuttons);
 
  if ($type eq "HEADER") {
    print "Content-type: text/html\n\n";
    print "<Html>\n";
    print "<head><title>Digital: $msg</title></head>\n";
    print "<Body bgcolor=\"f0f0f0\">\n";
    print "<center>\n";
    print "<img border=0 src=\"/images/config/voyagersmall.gif\" alt=Digital\n";

    print "<br>\n";
    print "<table><tr>\n";
    print "<td><a href=\"/\"><img border=0 src=\"/images/config/home.gif\" alt=\"Home\"></a>\n";
    if ($top) { print "<td><a href=\"$top\"><img border=0 src=\"/images/config/wrenchsmall.gif\" alt=\"Up\"></a>\n"; }
    if ($up) { print "<td><a href=\"$up\"><img border=0 src=\"/images/config/uparrow.gif\" alt=\"Up\"></a>\n"; }
    if ($help_page) { 
      if ($ihelp eq "off") {
	print "<td><a href=\"$help_page\"><img border=0 src=\"/images/config/ihelp-on.gif\" alt=\"IHelp\"></a>\n"; 
      }
      else {
	print "<td><a href=\"$help_page\"><img border=0 src=\"/images/config/ihelp-off.gif\" alt=\"IHelp\"></a>\n"; 
      }
    }
    if ($doc) { 
	print "<td><a href=\"$doc\"><img border=0 src=\"/images/config/help.gif\" alt=\"Help\"></a>\n"; 
    }
    print "</tr><tr>\n";

    print "</tr></table>\n";
    print "<hr>\n";
    print "<font size=+2>$msg</font>\n";
    print "<hr>\n";
    print "</center>\n";
  }
  elsif ($type eq "TRAILER") {
    print "<hr>\n";
    print "<center>\n";
      print "<table><tr>";
      print "<td><a href=\"/\"><img border=0 src=\"/images/config/home.gif\" alt=\"Home\"></a>\n";
      if ($top) { print "<td><a href=\"$top\"><img border=0 src=\"/images/config/wrenchsmall.gif\" alt=\"Up\"></a>\n"; }
      if ($up) { print "<td><a href=\"$up\"><img border=0 src=\"/images/config/uparrow.gif\" alt=\"Up\"></a>\n"; }
      if ($help_page) { 
	if ($ihelp eq "off") {
	  print "<td><a href=\"$help_page\"><img border=0 src=\"/images/config/ihelp-on.gif\" alt=\"IHelp\"></a>\n"; 
	}
	else {
	  print "<td><a href=\"$help_page\"><img border=0 src=\"/images/config/ihelp-off.gif\" alt=\"IHelp\"></a>\n"; 
	}
      }
      if ($doc) { print "<td><a href=\"$doc\"><img border=0 src=\"/images/config/help.gif\" alt=\"Help\"></a>\n"; }
      print "</tr><tr>\n";

#      print "<td align=center>Home\n";
#      if ($top) { print "<td align=center>Top\n"; }
#      if ($up) { print "<td align=center>Up\n"; }
#      if ($help_page) { print "<td align=center>Help\n"; }
#      if ($doc) { print "<td align=center>Doc\n"; }
      print "</tr></table>\n";
    print "</center>\n";
    print "</body></html>\n";
  }
  elsif ($type eq "GOTO") {
    print "Location: $msg\n\n";
    print "<html><body>\n";
  }
  elsif ($type eq "HOME") {
    print "Location: qos.pl\n\n";
    print "<html><body>\n";
  }
}


sub DeleteValue {
    local($pat) = @_;
#    open(FD, "$DSAVE -L -s '$pat' |");
    open(FD, "$DSAVE -s '$pat' |");

    @answer = ();
    while (<FD>) {
	push(@answer, $line);
    }
    close(FD);
    return(@answer);
}


#
# Display Forward options: called from forward.pl
#
sub disp_fwdoption {
    local($fwdoption) = @_;

    print "<SELECT NAME=\"FwdOption\" SIZE=1>\n";

    foreach $item (@FWDOPTION) {
	if ($fwdoption eq $item) {
    	    print "<OPTION SELECTED>$fwdoption";
	} else {
    	    print "<OPTION>$item";
	}
    }
    print "</SELECT>\n";
}

sub disp_policy_list {
#print "disp_policy_list: PolicyListSize=$PolicyListSize. default=$default_policy.<br>\n";
    if ($PolicyListSize <= $ListSize) {
        print "<SELECT NAME=\"TableSelect\" SIZE=\"$PolicyListSize\">\n";
    }
    else {
        print "<SELECT NAME=\"TableSelect\" SIZE=$ListSize>\n";
    }

    foreach $pitem (@POLICYLIST) {
	$item = $pitem;
	if ($pitem eq $default_policy) {
	    $item = "$pitem (default)";
	}
	if ($pitem eq $mastertable) {
	    print "<OPTION SELECTED>$item";
	}
	else {
	    print "<OPTION>$item";
	}
    }
    print "</SELECT>\n";
}   

sub disp_clist {
    local($selectClass) = @_;

    if ($selectClass ne "") {
	$c = 1;
    }
    else {
	$c = 0;
    }

    if ($ClassListSize < $ListSize) {
	print "<SELECT NAME=\"Select\" SIZE=$ClassListSize>\n";
    }
    else {
	print "<SELECT NAME=\"Select\" SIZE=$ListSize>\n";
    }
    foreach $item (@CLASSLIST) {
	if (!$c || $item eq $selectClass) {
	    print "<OPTION SELECTED>$item";
	    $c = 1;
	}
	else {
	    print "<OPTION>$item";
	}
    }
    print "</SELECT>";
}


sub disp_swlist {
    local($selectswitch, $size) = @_;

    if ($selectswitch ne "") {
	$c = 1;
    }
    else {
	$c = 0;
    }

    if ($size eq "1") {
	print "<SELECT NAME=\"SWSelect\" SIZE=1>\n";
    }
    else {
	if ($ForwardListSize < $ListSize) {
	    print "<SELECT NAME=\"SWSelect\" SIZE=$ForwardListSize>\n";
	}
	else {
	    print "<SELECT NAME=\"SWSelect\" SIZE=$ListSize>\n";
	}
    }

    foreach $item (@FORWARDLIST) {
	if (!$c || $item eq $selectswitch) {
	    print "<OPTION SELECTED>$item";
	    $c = 1;
	}
	else {
	    print "<OPTION>$item";
	}
    }
    print "</SELECT>";
}

sub disp_rules {
    local($name, $size, $start) = @_;
#print "disp_rules: ", &ctime(time), "<br>\n";

    if (!$PNlistSize) {
	print "There is no rule defined for this policy.<br>\n";
	return NULL;
    }

    if ($size != 0) {
	print "<SELECT NAME=\"SelectPolicy\" SIZE=$size>\n";
    }
    else {
	if ($PNlistSize <= $ListSize) {
	    $newsize = $PNlistSize + 1;
	    print "<SELECT NAME=\"SelectPolicy\" SIZE=$newsize>\n";
	}
	else {
	    print "<SELECT NAME=\"SelectPolicy\" SIZE=$ListSize>\n";
	}
    }

    # rule name, src, src port, dst, dst port, interface, inbound,
    # outbound, ipproto, filter, priority, fowarding rule
    for ($i=0; $i< $PNlistSize; $i++) {
	$item = $PNAMELIST[$i];
	$po = $PLIST[$i];
	@current_class = grep(/^machine:$mname:policy:class:$mastertable-$item:/, @class_items);
	$for = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$po:swt");
	$int = &GetClassValue("machine:$mname:policy:class:$mastertable-$item:interface");
	$src = &GetClassValue("machine:$mname:policy:class:$mastertable-$item:src ");
	$dst = &GetClassValue("machine:$mname:policy:class:$mastertable-$item:dst ");
	$ipproto = &GetClassValue("machine:$mname:policy:class:$mastertable-$item:ipproto");
	$srcport = &GetClassValue("machine:$mname:policy:class:$mastertable-$item:srcport");
	$dstport = &GetClassValue("machine:$mname:policy:class:$mastertable-$item:dstport");
	$inbound = &GetClassValue("machine:$mname:policy:class:$mastertable-$item:inbound");
	$outbound = &GetClassValue("machine:$mname:policy:class:$mastertable-$item:outbound");

	if ($PNAMELIST[$i] eq $selectpolicy) {
	    print "<OPTION SELECTED>", $item, " ",
		"[forward:", $for, "] ",
		"[filter:", $PFLIST[$i], "] ",
		"[priority:", $PPLIST[$i], "] ",
		"[src:", $src, "] ",
		"[sport:", $srcport, "] ",
		"[dst:", $dst, "] ",
		"[dport:", $dstport, "] ",
		"[interface:", $int, "] ",
		"[proto:", $ipproto, "] ",
		"[In:", $inbound, "] ",
		"[Out:", $outbound, "]";
	}
	else {
	    print "<OPTION>", $item, " ", 
		"[forward:", $for, "] ",
		"[filter:", $PFLIST[$i], "] ",
		"[priority:", $PPLIST[$i], "] ",
		"[src:", $src, "] ",
		"[sport:", $srcport, "] ",
		"[dst:", $dst, "] ",
		"[dport:", $dstport, "] ",
		"[interface:", $int, "] ",
		"[proto:", $ipproto, "] ",
		"[In:", $inbound, "] ",
		"[Out:", $outbound, "]";
	}
    }
    if ($start == 0) {
        print "<OPTION>$IMPLICITSHORT";
    } elsif ($start == 1) {
        print "<OPTION> $IMPLICITLONG";
    }

    print "</SELECT>";
#print "<br>disp_rules: ", &ctime(time), "<br>\n";
}


sub disp_nrlist {
    local($name, $before) = @_;
    if (!$PNlistSize) {
	print "There is no flow policy defined for this table.<br>\n";
	return NULL;
    }

    print "<SELECT NAME=\"$name\" SIZE=1>\n";

    for ($i=1; $i <= $PNlistSize; $i++) {
	if ($PNAMELIST[$i-1] eq $selectpolicy) {
	    print "<OPTION SELECTED>$PNAMELIST[$i-1]";
	}
	else {
	    print "<OPTION>$PNAMELIST[$i-1]";
	}
    }

    if ($before == 0) {
	print "<OPTION> $IMPLICITSHORT";
    }

    print "</SELECT>";
}

#
# display filter action list.
#
sub disp_filterlist {
    local($filter) = @_;

    print "<SELECT NAME=\"FilterSelect\">\n";
    foreach $item (@FILTERLIST) {
	if ($item eq "$filter") {
	    print "<OPTION SELECTED>$filter";
	}
	else {
	    print "<OPTION>$item";
	}
    }
    print "</SELECT>\n";
}

sub disp_iflist {
    local($interface) = @_;
#print "disp_iflist: interface=$interface, INTERFACELIST=@INTERFACELIST.<br>";
    print "<SELECT NAME=\"Interface\">\n";
    foreach $item (@INTERFACELIST) {
	if ($item eq "$interface") {
	    print "<OPTION SELECTED>$interface";
	}
	else {
	    print "<OPTION> $item";
 	}
    }
    print "</SELECT>\n";
}

# display priority list
sub disp_priolist {
    local($priority) = @_;

    print "<SELECT NAME=\"PrioSelect\">\n";
    foreach $item (@PIORLIST) {
	if ($item eq "$priority") {
	    print "<OPTION SELECTED>$priority";
	}
	else {
	    print "<OPTION>$item";
	}
    }
    print "</SELECT>\n";
}

sub disp_fplist {
    local($flowproto) = @_;

    print "<SELECT NAME=\"FlowProto\">\n";
    foreach $item (@FLOWPLIST) {
	if ($item eq "$flowproto") {
	    print "<OPTION SELECTED>$flowproto";
	}
	else {
	    print "<OPTION>$item";
	}
    }
    print "</SELECT>\n";
}

sub disp_services {

    print "<SELECT SIZE=1>\n";
    foreach $item (@SERVICES) {
    	print "<OPTION>$item\n";
    }
    print "</SELECT>\n";
}

sub disp_ipplist {

    print "<SELECT SIZE=1>\n";
    foreach $item (@IPPLIST) {
    	print "<OPTION>$item\n";
    }
    print "</SELECT>\n";
}

sub disp_ipproto {
    local($ipprot) = @_;

    print "<SELECT NAME=\"IPproto\">\n";
    print "<OPTION>$ipprot";
    print "</SELECT>\n";
}

sub get_data {
#print "get_data: ", &ctime(time), "<br>\n";
#    open(FD, "$DSAVE -L -n |");
    open(FD, "$DSAVE -n |");
    @a = <FD>;
    close(FD);
    $mname = &get("machine");
#print "get_data: ", &ctime(time), "<br>\n";
}

sub get_new_policies {
#print "get_new_policies: ", &ctime(time), "<br>\n";
    open(FD, "$DSAVE -c |");
    @ap = <FD>;
    close(FD);
    $mname = &get("machine");
    @all_policies = grep(/^machine:$mname:policy:qostable:/, @ap);
    @class_items = grep(/^machine:$mname:policy:class:/, @ap);
    @a = @ap;
#print "get_new_policies: ", &ctime(time), "<br>\n";
}

sub get_new_classes {
    open(FD, "$DSAVE -c |");
    @ac = <FD>;
    close(FD);
    @class_items = grep(/^machine:$mname:policy:class:/, @ac);
}

sub get_policies {
#print "get_policies.<br>\n";
    @POLICYLIST = ();

    @all_policies = grep(/^machine:$mname:policy:qostable:/, @a);

    foreach $line (@all_policies) {
	($a, $b, $c, $d, $n, $r) = split(/:/, $line, 6);
	if (!$r) {
	    ($n, $a) = split(/ /, $n);
	}
	$count = grep(/$n/, @POLICYLIST);
	if (!$count && $n ne "control") {
	    push(@POLICYLIST, $n);
	}
    }

    $PolicyListSize = @POLICYLIST;
#    print "get_data: Found policy tables: @POLICYLIST<br>\n";

    if ($mastertable eq "") {
	$m = $POLICYLIST[0];
	($mastertable, $j) = split(' ', $m);
    }
}

sub get_forwarding_rules {

    @FORWARDLIST = ();

    @all_swt = grep(/machine:$mname:policy:swt:/, @a);

    foreach $line (@all_swt) {
	$count = grep(/ t/, $line);
	if (!$count) {
	  ($a, $b, $c, $d, $s, $r) = split(/:/, $line, 6);
	  $count = 0;
	  for $i (@FORWARDLIST) {
	    if ("$i" eq "$s") {
		$count = 1;
	    }
	  }
	  if (!$count) {
	      push(@FORWARDLIST, $s);
	  }
	}
    }

    $ForwardListSize = @FORWARDLIST;
#    print "Found switch policies: @FORWARDLIST<br>\n";
}

sub get_interfaces {
#print "get_interfaces: ", &ctime(time), "<br>\n";
    @INTERFACELIST = ();
    @interfaces = grep(/^machine:$mname:interface:/, @a);

    foreach $line (@interfaces) {
	($m, $mn, $i, $i, $r) = split(/:/, $line, 5);
	if (!$r) {
	    chop $i;
	    ($ifname, $r) = split(' ', $i, 2);
	    $l = &get("machine:$mname:interface:$ifname:lname");
	    if ($l) {
	      if ("$ifname" ne "$l") {
		$ifname = "$ifname ($l)";
	      }

	      $count = 0;
	      foreach $if (@INTERFACELIST) {
		if ("$if" eq "$ifname") {
		    $count = 1;
		}
	      }
	      if (!$count) {
	        push(@INTERFACELIST, "$ifname");
	      }
	    }
	}
	else {
	    $count = grep(/ t/, $line);
	    if (!$count) {
	    	($m, $mn, $i, $ifname, $r) = split(/:/, $line, 5);
		$l = &get("machine:$mname:interface:$ifname:lname");
	        if ($l) {
	      	  if ("$ifname" ne "$l") {
		    $ifname = "$ifname ($l)";
		  }

		  $count = 0;
		  foreach $if (@INTERFACELIST) {
		    if ("$if" eq "$ifname") {
			$count = 1;
		    }
		  }
	          if (!$count) {
	            push(@INTERFACELIST, "$ifname");
	          }
		}
	    }
	}
    }

    push(@INTERFACELIST, "any");
#print "get_interfaces: ", &ctime(time), "<br>\n";
}

sub get_default_policy {
    $default_policy = &GetValue("machine:$mname:policy:qostable:control:default:name");
}


sub get_clist {
#print "get_clist: ", &ctime(time), "<br>\n";
    @CLASSLIST = ();

    @class_items = grep(/^machine:$mname:policy:class:/, @a);

    foreach $line (@class_items) {
	($a, $b, $c, $d, $n, $r) = split(/:/, $line, 6);
	$count = grep(/$n/, @CLASSLIST);
	if (!$count && $r) {
	    push(@CLASSLIST, $n);
	}
    }

    $ClassListSize = @CLASSLIST;
#    print "Found classes: @CLASSLIST<br>\n";
#print "get_clist: ", &ctime(time), "<br>\n";
}

sub bynumber { $a <=> $b; }

sub get_rules_from_current_policy {
#print "get_rules_from_current_policy: ", &ctime(time), "<br>\n";

    @plist = ();	# rule order list in unsorted order
    @PLIST = ();	# rule order list in sorted order
    @PNAMELIST = ();	# rule name list
    @PFLIST = ();	# filtering option list
    @PPLIST = ();	# priority list

#    print "Found rules in current policy $mastertable: @policy_items.<br>\n";

    foreach $line (@policy_items) {
	($a, $b, $c, $n, $q, $p, $r) = split(/:/, $line, 7);
	$limit = @plist;
	$found = 0;
	for ($i=0; $i<$limit; $i++) {
	    	if ( $p eq $plist[$i] ) {
		    $found = 1;
	    	}
	}
	if (!$found && $r) {
	    	push(@plist, $p);
	}
    }

    @PLIST = sort bynumber @plist;
    $PlistSize = @PLIST;
#    print "Found rules in current policy table $mastertable: @PLIST<br>\n";

    foreach $item (@PLIST) {
	$n = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$item:name");
	push(@PNAMELIST, $n);
    }

    $PNlistSize = @PNAMELIST;
#    print "$PNlistSize Policy names in current table are: $PNAMELIST.<br>";

    foreach $item (@PLIST) {
	$n = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$item:filter");
	push(@PFLIST, $n);
    }

    foreach $item (@PLIST) {
	$n = &GetPolicyValue("machine:$mname:policy:qostable:$mastertable:$item:priority");
	push(@PPLIST, $n);
    }
#print "get_rules_from_current_policy: ", &ctime(time), "<br>\n";
}


sub get_ipproto_list {
    @IPPLIST = ();

    @items = grep(/^ipproto:/, @a);

    foreach $line (@items) {
	@a = split(/:/, $line, 2);
	$b = $a[1];
	($c, $i) = split(' ', $b);
	$count = grep(/:/, $c);
	if (!$count) {
	    $count = grep(/$c/, @IPPLIST);
	    if (!$count) {
	    	push(@IPPLIST, "$c ($i)");
	    }
	}
    }

    $IPPListSize = @IPPLIST;
#    print "Found ipproto list: @IPPLIST<br>\n";
}


sub GetPolicyOrder {
    local($m, $s) = @_;
#print "GetPolicyOrder: m=$m, s=$s.<br>";

    if (!@all_policies) {
	@all_policies = grep(/^machine:$mname:policy:qostable:/, @a);
    }
    @i = grep(/^machine:$mname:policy:qostable:$m/, @all_policies);

    $count = grep(/:class $m-$s$/, @i);
    @items = grep(/:class $m-$s$/, @i);

    if ($count) {
	$line = $items[0];
	@b = split(/:/, $line);
	$order = $b[5];
	return $order;
    }
    else {
	return 0;
    }
}

sub GetNewPolicyOrder {
    local($m, $old) = @_;
    local($inc) = 1000;
    local($notdone) = 1;
    $i = 0;

    while ($i < $PlistSize && $PLIST[$i] != $old) {
        $i++;
    }

    if (!$i) {
	if (!$PlistSize) {
	    $diff = $INC;
	}
	elsif ($i < $PlistSize - 1) {
	    $diff = ($PLIST[$i+1] - $old)/2;
	}
	else {
	    $diff = $INC;
	}
    }
    elsif ($i == $PlistSize - 1) {
	$diff = $INC;
    }
    else {
	$diff = ($PLIST[$i+1] - $old)/2;
    }
    $new_order = $old + $diff;

    return $new_order;
}

sub CheckDuplicate {
    local($pat) = @_;

    $count = grep(/$pat/, @a);
    return $count;
}


sub GetValue {
    local($search) = @_;
#    open(FD, "$DSAVE -g '$search' |");
    open(FD, "/usr/local/config/bin/dbget '$search' |");
    $answer = <FD>;
    close(FD);

    chop $answer;
    return $answer; 
}

sub GetIndexedValue {
    local($search, $index) = @_;
    local($c2) = "";

    @b = grep(/^$search/, @a);
    foreach $g (@b) {
#      @barray = split(/:/, $g);
#      $c = $barray[$index];
      ($c1, $c2) = split(' ', $g);
#      print "g=$g, c1=$c1, c2=$c2.<br>";
    }
    return $c2;
}

sub GetPolicyValue {
    local($search) = @_;

    @b = grep(/^$search/, @policy_items);
    foreach $g (@b) {
      ($c1, $c2) = split(' ', $g);
#      print "g=$g, c1=$c1, c2=$c2.<br>";
    }
    return $c2;
}

sub GetClassValue {
    local($search) = @_;
    local($c2) = "";

    @b = grep(/$search/, @current_class);
#print "GetClassValue: search=$search. current_class=@current_class.<br>\n";
    foreach $g (@b) {
      ($c1, $c2) = split(' ', $g);
#      print "g=$g, c1=$c1, c2=$c2.<br>";
    }
    return $c2;
}

sub SetValue {
    local($str) = @_;
    open(FD, "$DSAVE -s '$str' |");
#    open(FD, "$DSAVE -L -s '$str' |");
#    open(FD, "/usr/local/config/bin/dbset '$str' |");
    $answer = <FD>;
    close(FD);

    if ($answer ne "") {
        $answer;
	print "SetValue: errors from dsave: $answer.<br>\n";
    }
    return($answer);
}

sub GetCurrentPolicy {
#print "GetCurrentPolicy: ", &ctime(time), "<br>\n";
    local($search);

    $mm = $GLOBAL{'TableSelect'};
    ($mastertable, $m) = split(' ', $mm);

    if (!$mastertable) {
	$mastertable = &GetValue("machine:$mname:policy:qostable:control:edit:name\n");
    }

    $search = "machine:$mname:policy:qostable:$mastertable:";
    @policy_items = grep(/$search/, @a);

    if (!$selectpolicy) {
	$selectpolicy = &GetValue("machine:$mname:policy:qostable:control:edit:rule\n");
	if (!$selectpolicy) {
	    &get_rules_from_current_policy;
	    $selectpolicy = $PNAMELIST[0];
	    $currorder = $PLIST[0];
	}
    }
    else {
	$o = &GetValue("machine:$mname:policy:qostable:control:edit:rule\n");
	if ($o ne $selectpolicy) {
	    &update_conf("\n\nmachine:$mname:policy:qostable:control:edit:rule $selectpolicy\napply apply\n", 0);
	}
    }

    $currorder = &GetPolicyOrder("$mastertable", "$selectpolicy");
#print "GetCurrentPolicy: mastertable=$mastertable, selectpolicy=$selectpolicy, currorder=$currorder.<br>\n";
#print "GetCurrentPolicy: ", &ctime(time), "<br>\n";
}

sub policy_error {
    local(@flag) = @_;
    @err_message = <FID>;
    $err_cnt = @err_message;
#print "err_cnt=$err_cnt, err_message=@err_message.<br>\n";

    if ($err_cnt) {
#	print "<center>\n";
#	print "<pre>\n";
#	print "<table>\n";
	print "<img src=\"/images/config/errorbar.gif\"><br>\n";
	foreach $line (@err_message) {
	    print "$line<br>\n";
	}
#	print "</table>\n";
#	print "</pre>\n";
	print "<img src=\"/images/config/redbar.gif\">\n";
#	print "</center>\n";
    }
    elsif ($flag > 0) {
	print "<img src=\"/images/config/apply.gif\"><br>\n";
	print "Apply successful<br>\n";
	print "<img src=\"/images/config/greenbar.gif\">\n";
    }
}

sub update_conf {
    local($opt, $flag) = @_;
#print "update_conf:", &ctime(time), "<br>\n";

    @err_messages = ();

#    open(FD, "| $DSAVE -L -S > /tmp/dsave.error");
    open(FD, "| $DSAVE -S > /tmp/dsave.error");
    print FD $opt;
    close(FD);

    open(FD, "</tmp/dsave.error");
    while (<FD>) {
	push(@err_messages, $_);
    }
    close(FD);
    unlink "/tmp/dsave.error";

#print "update_conf: err_messages=@err_messages.<br>\n";

    if (@err_messages) {
      print "<img src=\"/images/config/errorbar.gif\"><br>\n";
      foreach $line (@err_messages) {
	print "$line<br>\n";
      }
      print "<img src=\"/images/config/redbar.gif\"><br>\n";
    }
    else {
	if ($flag) {
	    print "<img src=\"/images/config/apply.gif\"><br>\n";
	    print "Apply successful<br>\n";
	    print "<img src=\"/images/config/greenbar.gif\"><br>\n";
	}
    }
#print "update_conf: end: ", &ctime(time), "<br>\n";
}

1;
