#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################
#
$WEBDIR         = "/usr/local/www";
$CGIDIR         = "$WEBDIR/cgi-bin";
#
$SYS_STATUS_FILE = "$CGIDIR/data/system";
$COMPONENT_FILE = "$CGIDIR/data/component";


sub genSystemStatus {
	local(*ipsD, *nicD, *chasD) = @_;
	local($_, $tmp);

        &readList(*componentList, $COMPONENT_FILE);
	&processArray(*componentList,*nameArray);

# Truncate/Open data/system for writing
#
        truncate($SYS_STATUS_FILE,0);
        open(SYS_ID, ">$SYS_STATUS_FILE");

# Generate system array
# Write system Array to data/system
#
        for ($chasNum =1; $chasD{$chasNum}; $chasNum++) {
		if ($chasNum eq 1) {
			$chasT = "pc";
        		print SYS_ID "system.chassis.$chasNum.type = $chasT\n";
        		for ($slotN=1; $slotN<=$nameArray{"component.chassis.$chasT.slotNumber"}; $slotN++) {
				$iName = sprintf("ifs%dp%dc%d.name", $slotN, 1, 0);
				if ($nicD{$iName}) {
					$cardT = "mmode-1";
        				for ($portN=1; $portN<=$nameArray{"component.card.$chasT.$cardT.portNumber"}; $portN++) {
						$iNum = sprintf("s%dp%dc%d", $slotN, $portN, 0);
#print "genSystemStatus(0): iNum($iNum)\n";
						$tmp = $nicD{"if$iNum.ifindex"};
#print "genSystemStatus(1): tmp($tmp)\n";
						$tmp = $nicD{"tool.iflist_to_if[$tmp]"};
#print "genSystemStatus(2): tmp($tmp)\n";
						$tmp = $nicD{"ips.if[$tmp].operstatus"};
#print "genSystemStatus(3): tmp($tmp)\n";
                                        	if ($tmp eq 1)
							{ $status = "up"; }
						else    
							{ $status = "down"; }
        					print SYS_ID "system.chassis.$chasNum.slot.$slotN.port.$portN.status = $status\n";
					}
				}
				else
					{ $cardT = "slot"; }
        			print SYS_ID "system.chassis.$chasNum.slot.$slotN.cardType = $cardT\n";
			}
		}
		if ($chasNum eq 2) {
			$chasT = "switch";
        		print SYS_ID "system.chassis.$chasNum.type = $chasT\n";
        		for ($slotN=1; $slotN<=$nameArray{"component.chassis.$chasT.slotNumber"}; $slotN++) {
				$iName = sprintf("if%d.name", $slotN);
				if ($ipsD{$iName}) {
					$cardT = "mmode-1";
        				for ($portN=1; $portN<=$nameArray{"component.card.$chasT.$cardT.portNumber"}; $portN++) {
						$iNum = $slotN;
						$tmp = $ipsD{"if$iNum.ifindex"};
						$tmp = $ipsD{"tool.iflist_to_if[$tmp]"};
						$tmp = $ipsD{"ips.if[$tmp].operstatus"};
                                        	if ($tmp eq 1)
							{ $status = "up"; }
						else    
							{ $status = "down"; }
        					print SYS_ID "system.chassis.$chasNum.slot.$slotN.port.$portN.status = $status\n";
					}
				}
				else
					{ $cardT = "slot"; }
        			print SYS_ID "system.chassis.$chasNum.slot.$slotN.cardType = $cardT\n";
			}
		}
		if ($chasNum eq 3) {
        		print SYS_ID "system.chassis.$chasNum.type = grouper\n";
		}
        }
        --$chasNum; print SYS_ID "system.chasNumber = $chasNum\n";

#Close data/system file
#
	close(SYS_ID);
}

1;
