#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################
#
$WEBDIR         = "/usr/local/www";
$CGIDIR         = "$WEBDIR/cgi-bin";

# readList component data/component
#
sub readList {
	local(*listName, $dataFile) = @_;
	local($i, $_);

	if (!open(R_FILE, $dataFile))
		{ print "readList(): can't open $dataFile.\n"; }
	$i = 0;
	while (<R_FILE>) {
		chop;
		if (/^#/ || /^$/)
			{ next; }
		$listName[$i++] = $_;
	}
	close(R_FILE);
}

#
# processArray parse list of name-value pairs in associative array
#
sub processArray {
	local(*listName, *arrayName) = @_;
	
	for (@listName) {
		if (/(\S*)\s=\s(\S*)/)
			{ $arrayName{$1} = $2; }
	}
}

# dumpList for debug
#
sub dumpList {
	local(*listName) = @_;
	local($_);

	for (@listName)
		{ print "dumpList($_)\n"; };
}

# dumpArray for debug
#
sub dumpArray {
	local(*arrayName) = @_;

	while (($key,$val) = each %arrayName) {
		print "dumpArray($key=$val)\n";
	}
}

1;
